#include<gtk/gtk.h>
#include<math.h>
#include<cairo.h>
#include<stdio.h>
#include<dirent.h>
#include<ctype.h>
#include<string.h>

#define HEADER_HEIGHT 30

#define WIDTH   640
#define HEIGHT  500

#define GWIDTH   600
#define GHEIGHT  125

typedef struct
{
  gchar *heading;
  gdouble font_size;
  gint lines_per_page;
  gchar **lines;
  gint num_lines;
  gint num_pages;
} PrintData;

typedef struct {
    float utilization;
	long int total_sum;
	long int idle;
} Core;

typedef struct {
    char nazev[50];
	char cache_size[15];
	float frekvence;
	int num_of_cores;
	float history_utilization[61];
	int history_index;
	Core core[24];
}Cpu;

typedef struct {
    float totalRam;
	float avRam;
	float swapTotal;
	float swapFree;
	float history_usage[61];
	int history_index;
	
}Ram;

typedef struct
{
	char disk_name[50];
	char type[20];
	char capacity[20];
	char used_space[20];
	char free_space[20];
	char connect_to[100];
} Disk;

typedef struct 
{
	char name[100];
	int pid;
	char status[20];
	char memory[10];
	char memoryVm[10];
}Proc;

struct swhw_detail{
    char os[50];
	char kernelRelease[50];
	char distro[50];
    char v_distro[50];
	char g_adapter[100];
	char board[100];
	int cnt_proc;
	int cnt_disk;
	Proc proc[500];
	Disk disk[20];
	Cpu cpu;
	Ram ram;
}swhw_d, *swhw_ptr;

enum
{
  COLUMN_PID,
  COLUMN_NAME,
  COLUMN_STATUS,
  COLUMN_MEMORY,
  COLUMN_MEMORYVM,
  NUM_COLUMNS
};

enum
{
  COLUMN_SYSTEM,
  COLUMN_TYPE,
  COLUMN_CAPACITY,
  COLUMN_USED,
  COLUMN_FREE,
  COLUMN_DESTINATION,
  NUMBER_COLUMNS
}; 

GtkWidget *create_window();																							//vytvoření hlavního okna

void about_app(GtkMenuItem *menuItem, gpointer user_data);															//zpětné volání - dialog s informacemi o aplikaci

int checkSubString(const char *stringFull, const char *stringPart);													//funkce na kontrolu shody dvou řetězců

void close_app(GtkWidget *window, gpointer data);																	//zpětné volání - zavření aplikace

void * start_printing (GtkWidget *do_widget, gpointer data);														//zpětné volání - tisk informací

void begin_print (GtkPrintOperation *operation, GtkPrintContext *context, gpointer user_data);						//zpětné volání - příprava pro tisk 

void draw_page (GtkPrintOperation *operation, GtkPrintContext *context, gint page_nr, gpointer user_data);			//zpětné volání - vykreslení stránky

void end_print (GtkPrintOperation *operation, GtkPrintContext   *context, gpointer user_data);						//zpětné volání - uvolnění paměti po tisku

gboolean draw_callback_cpu(GtkWidget *widget, cairo_t *cr, gpointer user_data);										//zpětné volání - vykreslení grafu vytížení procesoru 

gboolean draw_callback_ram(GtkWidget *widget, cairo_t *cr, gpointer user_data);										//zpětné volání - vykreslní grafu vytížení RAM

gboolean repaint_cpu(gpointer user_data);																			//funkce na akualizaci hodnot o vytížení procesoru - volána každou vteřinu

gboolean repaint_ram(gpointer user_data);																			//funkce na akualizaci hodnot o vytížení procesoru - volána každou vteřinu											
																	
void cpu_utilization();																								//funkce pro sbíraní a vypočtení hodnot o vytížení procesoru

float ram_usage();																									//funkce pro sbíraní a vypočtení hodnot o využití RAM

void initHwSwvalue();																								//funkce na inicializaci základních informací o softwaru a hardwaru

void get_process();																									//funkce na načtení a uložení běžících procesů

void get_disk();																									//funkce pro načtení připojených disků

gdouble graphGrid(GtkWidget *widget, cairo_t *cr);																	//pomocná funkce pro vykreslení plochy gafu, mřížky apod.

gboolean refresh_proc(gpointer user_data);																			//funkce a aktualizaci procesů

gboolean refresh_disk (GtkWidget *button, gpointer data);															//funkce zpětného volání pro aktualizaci souborových systémů

void quit_proces (GtkWidget *button, gpointer data);																//funkce zpětného volání pro ukončení vybraného procesu

void del_new_line(char *str, size_t len, int opt);																	//odmaže s načteného textového řádku znak pro nový řádek

float get_median(float tmpArray[], int length);																		//vrátí medián ze zadaného pole měřených historických hodnot
