#include "app_gtk.h"

int checkSubString(const char *stringFull, const char *stringPart)
{
	if(strncmp(stringFull, stringPart, strlen(stringPart))== 0)
		return 1;

	return 0;
}

void del_new_line(char *str, size_t len, int opt)
{
	if(len > 0 && str[len-1] == '\n')
	{
		if(opt == 0)
			str[--len] = '\0';
		else
			str[--len] = ' ';
	}
}

float get_median(float array[], int length)
{
	int i, j, tmp;
	float median = 0.0;
	float tmpArray[length];

	for(i = 0; i < length; i++)
		tmpArray[i] = array[i];
	
	for(i = 0; i < length; i++)
	{
		for(j = 0; j < length - 1; j++)
		{
			if(tmpArray[j] > tmpArray[j+1])
			{
				tmp = tmpArray[j];
				tmpArray[j] = tmpArray[j+1];
				tmpArray[j+1] = tmp;		
			}
		}
	}
	
	if(length%2 == 0)
		median = (tmpArray[(length-1)/2] + tmpArray[length/2])/2.0;
	else
		median = tmpArray[length/2];
	
	return median;

} 

void cpu_utilization(){
	FILE *stat;
	char str[200];			
	char *token;				
	int i, k;			
	float sumDiff, idleDiff, sum_times = 0.0, idle = 0.0;
	
	stat = fopen("/proc/stat", "r");

    if(stat != NULL)
    {	
		for(i=0; i <= swhw_ptr->cpu.num_of_cores; i++)
		{
			fgets(str, 200, stat);
			k = 0;
			for(token = strtok(str, " "); token!=NULL; token = strtok(NULL, " ")){
				if(k > 0){
					sum_times += atoi(token);
		
					if(k == 4)
						idle = atoi(token);
				}	
				k++;	
			}	

			if(swhw_ptr->cpu.history_index > 0){
				sumDiff = sum_times - swhw_ptr->cpu.core[i].total_sum;
				idleDiff = idle - swhw_ptr->cpu.core[i].idle;
				swhw_ptr->cpu.core[i].utilization = ((sumDiff - idleDiff)/(sumDiff)) * 100.0;
			}
			swhw_ptr->cpu.core[i].idle = idle;
			swhw_ptr->cpu.core[i].total_sum = sum_times;
			sum_times = 0;
		}
		fclose(stat);
	}
}

float ram_usage(){
	FILE *stat;
	char str[100];
	char *token;
	float ramUsage;

	stat = fopen("/proc/meminfo", "r");
	if(stat != NULL)		
    {
		while(fgets(str, 100, stat) != NULL){
			
			token = strtok(str, " ");
			token = strtok(NULL, " ");

			if(checkSubString(str, "MemTotal"))
				swhw_ptr->ram.totalRam = (atof(token)/1000.0);
			else if(checkSubString(str, "MemAvailable"))
					swhw_ptr->ram.avRam = (atof(token)/1000.0);
			else if(checkSubString(str, "SwapTotal"))
					swhw_ptr->ram.swapTotal = (atof(token)/1000.0);
			else if(checkSubString(str, "SwapFree"))
					swhw_ptr->ram.swapFree = (atof(token)/1000.0);
		}
		fclose(stat);	
	}
	ramUsage = (1 - swhw_ptr->ram.avRam / swhw_ptr->ram.totalRam) * 100.0; 
	
	return ramUsage;
}

void get_cpuInfo(FILE *stat)
{
	char str[100];			
	char *token;					
	int numLines = 0;	

	while(fgets(str, 100, stat) != NULL && numLines < 14 ) {      
		del_new_line(str, strlen(str), 0);
		token = strtok(str, ":");
		token = strtok(NULL, ":");

		if(checkSubString(str, "model name"))
			strncpy(swhw_ptr->cpu.nazev, token, 50);
		else if(checkSubString(str, "cpu MHz"))
			swhw_ptr->cpu.frekvence = atof(token);
		else if(checkSubString(str, "cpu cores"))
		    swhw_ptr->cpu.num_of_cores = atoi(token);
		else if(checkSubString(str, "cache size"))
			strncpy(swhw_ptr->cpu.cache_size, token, 15);

		numLines++;	
	}
}

void get_distroInfo(FILE *stat)
{
	char str[100];
	char *token;	

	while(fgets(str, 100, stat) != NULL)
	{	
		del_new_line(str, strlen(str), 0);	

		if(checkSubString(str, "NAME=")){
			 token = strtok(str, "=");
			 token = strtok(NULL, "=");
			 strncpy(swhw_ptr->distro, token, 50);
		}
		else if(checkSubString(str, "VERSION=")){
			token = strtok(str, "=");
			token = strtok(NULL, "=");
			strncpy(swhw_ptr->v_distro, token, 50);
		}	
	}
}

void get_osInfo(FILE *stat)
{
	char str[50];
	char *token;

	if(fgets(str, 100, stat) != NULL){
		del_new_line(str, strlen(str), 0);
		token = strtok(str, " ");
		strncpy(swhw_ptr->kernelRelease, token, 50);
		token = strtok(NULL, " ");
		strncpy(swhw_ptr->os, token, 50);
	}
	else{
		swhw_ptr->os[0] = '-';
		swhw_ptr->kernelRelease[0] = '-';
	}
}

void get_graphicInfo(FILE *stat)
{
	char str[100];
	if(fgets(str, 100, stat) != NULL){
		del_new_line(str, strlen(str), 0);
		strncpy(swhw_ptr->g_adapter, str, 100);
	}
	else
		swhw_ptr->g_adapter[0] = '-';	
}

void get_boardInfo()
{
	FILE *stat;	
	char str[100];

	swhw_ptr->cpu.history_index = 0;
	swhw_ptr->ram.history_index = 0;

	stat =  fopen("/sys/devices/virtual/dmi/id/board_name", "r");
	if(fgets(str, 100, stat) != NULL){
		del_new_line(str, strlen(str), 1);
		strcpy(swhw_ptr->board, str);
	}
	fclose(stat);	
	
	stat =  fopen("/sys/devices/virtual/dmi/id/board_vendor", "r");
	if(fgets(str, 100, stat) != NULL){
		del_new_line(str, strlen(str), 0);
		strcat(swhw_ptr->board, str);
	}
	fclose(stat);			
}

void initHwSwvalue(){
	
	FILE *stat;
	swhw_ptr = &swhw_d;

	stat = fopen("/proc/cpuinfo", "r");
    if(stat != NULL)			
    {
		get_cpuInfo(stat);
		fclose(stat);
    }else{
		swhw_ptr->cpu.nazev[0] = '-';
		swhw_ptr->cpu.frekvence = 0.0;
		swhw_ptr->cpu.num_of_cores = 0;
		swhw_ptr->cpu.cache_size[0] = '-';
	}

	stat = fopen("/etc/os-release", "r");
    if(stat != NULL)			
    {
		get_distroInfo(stat);
		fclose(stat);	
	}
	else{
		swhw_ptr->distro[0] = '-';
		swhw_ptr->v_distro[0] = '-';
	}

	stat = popen("uname -ro 2>/dev/null", "r");		
	get_osInfo(stat);
	pclose(stat);	

	stat = popen("lspci | grep -E '(VGA compatible|Display|3D) controller' | cut -d':' -f3 | sed 's/^ *//' 2>/dev/null", "r");
	get_graphicInfo(stat);
	pclose(stat);	
	
	swhw_ptr->ram.history_usage[0] = ram_usage();
	get_boardInfo();
	get_disk();
}

void get_process(){
	char *path;
	FILE *stat;
	char *token;
	char *vmsize;
	char str[100];
	int k = 0;
	struct dirent *de;
	DIR *dr = opendir("/proc");

	swhw_ptr->cnt_proc = 0;
	if(dr != NULL)
	{
		while((de = readdir(dr)) != NULL){
		
		if(de->d_type == DT_DIR && isdigit(de->d_name[0])){	
		
			path = g_strdup_printf("/proc/%s/status", de->d_name);
			stat = fopen(path, "r");
			if(stat != NULL)		
    		{
				while(fgets(str, 100, stat) != NULL){
					del_new_line(str, strlen(str), 0);

					token = strtok(str, "\t");
					token = strtok(NULL, "\t");
					
					if(checkSubString(str, "Name:"))
						strncpy(swhw_ptr->proc[k].name, token, 100);	
					else if(checkSubString(str, "Pid:"))
						swhw_ptr->proc[k].pid = atoi(token);
					else if(checkSubString(str, "State:"))
						strncpy(swhw_ptr->proc[k].status, token, 20);
					else if(checkSubString(str, "VmRSS:")){
						vmsize = token;
						token = strtok(vmsize, " ");
						snprintf(swhw_ptr->proc[k].memory, 10 ,"%.1f MB", atof(token)/1000.0);
					}
					else if(checkSubString(str, "VmSize:")){
						vmsize = token;
						token = strtok(vmsize, " ");
						snprintf(swhw_ptr->proc[k].memoryVm, 10 ,"%.1f MB", atof(token)/1000.0);
					}	
				}
				fclose(stat);	
			}
			k++;
			g_free(path);
		}
	}
	closedir(dr);
	}
	swhw_ptr->cnt_proc = k;
}

void get_disk(){
	FILE *stat;
	char *token;
	char str[100];
	int i = 0, k = 0;
	swhw_ptr->cnt_disk = 0;
	stat = popen("df -HT --exclude-type=tmpfs --exclude-type=devtmpfs | tail -n +2", "r");
	if(stat != NULL)		
    {
		while(fgets(str, 100, stat) != NULL){
			del_new_line(str, strlen(str), 0);

			i = 0;
			for(token = strtok(str, " "); token!=NULL; token = strtok(NULL, " ")){
				if(i == 0)
					strncpy(swhw_ptr->disk[k].disk_name, token, 50);
				else if(i == 1)
					strncpy(swhw_ptr->disk[k].type, token, 20);	
				else if(i == 2)
					strncpy(swhw_ptr->disk[k].capacity, token, 20);	
				else if(i == 3)
					strncpy(swhw_ptr->disk[k].used_space, token, 20);	
				else if(i == 4)
					strncpy(swhw_ptr->disk[k].free_space, token, 20);	
				else if(i == 6)
					strncpy(swhw_ptr->disk[k].connect_to, token, 100);	
					
				i++;
			}		
			k++;
		}
	pclose(stat);	
	}
	swhw_ptr->cnt_disk = k;
}

